---
title: <input type="hidden">
slug: Web/HTML/Element/input/hidden
tags:
  - Element
  - Forms
  - HTML
  - HTML forms
  - Input
  - Input Types
  - Reference
  - hidden
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">{{HTMLElement("input")}} elements of type <strong><code>hidden</code></strong> let web developers include data that cannot be seen or modified by users when a form is submitted. For example, the ID of the content that is currently being ordered or edited, or a unique security token. Hidden inputs are completely invisible in the rendered page, and there is no way to make it visible in the page's content.</span></p>

<div class="note">
<p><strong>Note</strong>: There is a live example below the following line of code — if it is working correctly, you should see nothing!</p>
</div>

<div id="Basic_example">
<pre class="brush: html notranslate">&lt;input id="prodId" name="prodId" type="hidden" value="xm234jq"&gt;</pre>

<p>{{ EmbedLiveSample('Basic_example', 600, 40) }}</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <td><strong>{{anch("Value")}}</strong></td>
   <td>A {{domxref("DOMString")}} representing the value of the hidden data you want to pass back to the server.</td>
  </tr>
  <tr>
   <td><strong>Events</strong></td>
   <td>None.</td>
  </tr>
  <tr>
   <td><strong>Supported Common Attributes</strong></td>
   <td>{{htmlattrxref("autocomplete", "input")}}</td>
  </tr>
  <tr>
   <td><strong>IDL attributes</strong></td>
   <td><code>value</code></td>
  </tr>
  <tr>
   <td><strong>Methods</strong></td>
   <td>None.</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note</strong>: The {{domxref("HTMLElement/input_event", "input")}} and {{domxref("HTMLElement/change_event", "change")}} events do not apply to this input type. Hidden inputs cannot be focused even using JavaScript (e.g. <code>hiddenInput.focus()</code>).</p>
</div>

<h2 id="Value">Value</h2>

<p>The {{HTMLElement("input")}} element's {{htmlattrxref("value", "input")}} attribute holds a {{domxref("DOMString")}} that contains the hidden data you want to include when the form is submitted to the server. This specifically can't be edited or seen by the user via the user interface, although you could edit the value via browser developer tools.</p>

<div class="warning">
<p><strong>Important:</strong> While the value isn't displayed to the user in the page's content, it is visible—and can be edited—using any browser's developer tools or "View Source" functionality. Do not rely on <code>hidden</code> inputs as a form of security.</p>
</div>

<h2 id="Additional_attributes">Additional attributes</h2>

<p>In addition to the attributes common to all {{HTMLElement("input")}} elements, <code>hidden</code> inputs offer the following attributes:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>{{anch("name")}}</code></td>
   <td>Like all input types, the name of the input to report when submitting the form; the special value <code>_charset_</code> causes the hidden input's value to be reported as the character encoding used to submit the form</td>
  </tr>
 </tbody>
</table>

<h3 id="htmlattrdefname">{{htmlattrdef("name")}}</h3>

<p>This is actually one of the common attributes, but it has a special meaning available for hidden inputs. Normally, the {{htmlattrxref("name", "input")}} attribute functions on hidden inputs just like on any other input. However, when the form is submitted, a hidden input whose <code>name</code> is set to <code>_charset_</code> will automatically be reported with the value set to the character encoding used to submit the form.</p>

<h2 id="Using_hidden_inputs">Using hidden inputs</h2>

<p>As mentioned above, hidden inputs can be used anywhere that you want to include data the user can't see or edit along with the form when it's submitted to the server. Let's look at some examples that illustrate its use.</p>

<h3 id="Tracking_edited_content">Tracking edited content</h3>

<p>One of the most common uses for hidden inputs is to keep track of what database record needs to be updated when an edit form is submitted. A typical workflow looks like this:</p>

<ol>
 <li>User decides to edit some content they have control over, such as a blog post, or a product entry. They get started by pressing the edit button.</li>
 <li>The content to be edited is taken from the database and loaded into an HTML form to allow the user to make changes.</li>
 <li>After editing, the user submits the form, and the updated data is sent back to the server to be updated in the database.</li>
</ol>

<p>The idea here is that during step 2, the ID of the record being updated is kept in a hidden input. When the form is submitted in step 3, the ID is automatically sent back to the server with the record content. The ID lets the site's server-side component know exactly which record needs to be updated with the submitted data.</p>

<p>You can see a full example of what this might look like in the {{anch("Examples")}} section below.</p>

<h3 id="Improving_website_security">Improving website security</h3>

<p>Hidden inputs are also used to store and submit security tokens or <em>secrets</em>, for the purposes of improving website security. The basic idea is that if a user is filling in a sensitive form, such as a form on their banking website to transfer some money to another account, the secret they would be provided with would prove that they are who they say they are, and that they are using the correct form to submit the transfer request.</p>

<p>This would stop a malicious user from creating a fake form, pretending to be a bank, and emailing the form to unsuspecting users to trick them into transferring money to the wrong place. This kind of attack is called a <a href="/en-US/docs/Learn/Server-side/First_steps/Website_security#Cross-Site_Request_Forgery_(CSRF)">Cross Site Request Forgery (CSRF)</a>; pretty much any reputable server-side framework uses hidden secrets to prevent such attacks.</p>

<div class="note">
<p>As stated previously, placing the secret in a hidden input doesn't inherently make it secure. The key's composition and encoding would do that. The value of the hidden input is that it keeps the secret associated with the data and automatically includes it when the form is sent to the server. You need to use well-designed secrets to actually secure your website.</p>
</div>

<h2 id="Validation">Validation</h2>

<p>Hidden inputs don't participate in constraint validation; they have no real value to be constrained.</p>

<h2 id="Examples">Examples</h2>

<p>Let's look at how we might implement a simple version of the edit form we described earlier (see {{anch("Tracking edited content")}}), using a hidden input to remember the ID of the record being edited.</p>

<p>The edit form's HTML might look a little bit like this:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;div&gt;
    &lt;label for="title"&gt;Post title:&lt;/label&gt;
    &lt;input type="text" id="title" name="title" value="My excellent blog post"&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;label for="content"&gt;Post content:&lt;/label&gt;
    &lt;textarea id="content" name="content" cols="60" rows="5"&gt;
This is the content of my excellent blog post. I hope you enjoy it!
    &lt;/textarea&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;button type="submit"&gt;Update post&lt;/button&gt;
  &lt;/div&gt;
  &lt;input type="hidden" id="postId" name="postId" value="34657"&gt;
&lt;/form&gt;</pre>

<p>Let's also add some simple CSS:</p>

<pre class="brush: css notranslate">html {
  font-family: sans-serif;
}

form {
  width: 500px;
}

div {
  display: flex;
  margin-bottom: 10px;
}

label {
  flex: 2;
  line-height: 2;
  text-align: right;
  padding-right: 20px;
}

input, textarea {
  flex: 7;
  font-family: sans-serif;
  font-size: 1.1rem;
  padding: 5px;
}

textarea {
  height: 60px;
}</pre>

<p>The server would set the value of the hidden input with the ID "<code>postID</code>" to the ID of the post in its database before sending the form to the user's browser and would use that information when the form is returned to know which database record to update with modified information. No scripting is needed in the content to handle this.</p>

<p>The output looks like this:</p>

<p>{{ EmbedLiveSample('Examples', '100%', 200) }}</p>

<div class="note">
<p><strong>Note</strong>: You can also find the example on GitHub (see the <a href="https://github.com/mdn/learning-area/blob/master/html/forms/hidden-input-example/index.html">source code</a>, and also <a href="https://mdn.github.io/learning-area/html/forms/hidden-input-example/index.html">see it running live</a>).</p>
</div>

<p>When submitted, the form data sent to the server will look something like this:</p>

<p><code>title=My+excellent+blog+post&amp;content=This+is+the+content+of+my+excellent+blog+post.+I+hope+you+enjoy+it!&amp;postId=34657</code></p>

<p>Even though the hidden input cannot be seen at all, its data is still submitted.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#hidden-state-(type=hidden)', '&lt;input type="hidden"&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.2', 'sec-forms.html#hidden-state-typehidden', '&lt;input type="hidden"&gt;')}}</td>
   <td>{{Spec2('HTML5.2')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.input.input-hidden")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/Forms">HTML forms guide</a></li>
 <li>{{HTMLElement("input")}} and the {{domxref("HTMLInputElement")}} interface it's based upon</li>
</ul>
